// macro modified May 2014 by Laura Teigrob to include a fourth temperature of 25C, noted by "LT" next to changes

#define V0 50
#define EI 0.01 //1% error on currents
#define EG 0.01 //1% error on Gain
#define G0 250


#define GSTART 20
#define GDELTA 2
#define GPOINTS 85

#define NPT100 2

#define EPS 0.1 //for 1/G dG/dV calculation


int Nexpo=2;

#include <vector>
#include "limits"

extern "C" int my_isinf(double x);


struct apd_t {
	double id;
        double G1_25;
        double G2_25;                           // LT
        double G3_25;
    	double G1_20;
    	double G2_20;
    	double G3_20;  
    	double G1_18;
    	double G2_18;
    	double G3_18;  
        double G1_16;
    	double G2_16;
    	double G3_16;
        double V1_25;                           //LT
        double V2_25;
        double V3_25;
    	double V1_20;
    	double V2_20;
    	double V3_20;  
    	double V1_18;
    	double V2_18;
    	double V3_18;  
    	double V1_16;
    	double V2_16;
    	double V3_16;  
	double ratio;
	double delta_ratio;
	double Vbreak;
	double VHam;
        double grpGN;
	int ok_flag;
	};


void tree_05_19_2014_TEMP_CORR(){

// ----- Definisco il file .root in cui salvare la tree -----
// ----- -----

	// ----- Modified by HS 02/04/2014 -----
   double V1,V2,V3;
   double T1,T2,T3,T4;       // LT
   double G1,G2,G3;
	T1=17;
	T2=18;
	T3=20;
	T4=25;                           // LT
	V1=380;
	V2=385;
	V3=390;
	G1=50;
	G2=100;
	G3=150;
	// ----- -----
	double ratio, delta_ratio;
  gROOT->SetStyle("Plain");
  gStyle->SetNumberContours(100);
  //First read file "last.txt" in this dir and fill relevant info, that are simply the number of APDs being analized and their ID.
  int nAPD,*apdID, *Vbreak;
  double *VHam;
  int *ok_flag;
  ifstream file("last.txt");
  ifstream file_Vb("Break.txt");
  ifstream file_Vh("Vhamamatsu.txt");
  ifstream file_flag("flag.txt");
  file>>nAPD;
  apdID=new int[nAPD];
  Vbreak=new int[nAPD];
  ok_flag=new int[nAPD];
  VHam=new double[nAPD];
  for (int ii=0;ii<nAPD;ii++) {
	 file>>apdID[ii];
	 file_Vb>>Vbreak[ii];
	 file_Vh>>VHam[ii];
	 file_flag>>ok_flag[ii];

	}
  file.close();
 


  //prepare relevant variable
  ifstream data;

  vector< vector< double > > V;
  vector< vector< double > > Vr;
  vector< vector< double > > I;
  vector< vector< double > > Id;
  vector< vector< double > > Ir;
  vector< vector< double > > G;

  double *Tset,*realT,*startT,*endT;
  double singleTmeas[NPT100];
  
  vector< double* > Tmeas;
  vector< double > meanTmeas;
  double tempTmeas;

  TString dummyS,dummyS1;
  long int Tcounter;
  int *nData;
 
  TGraph **gTemperature;
  int nT;


  //Then start the loop on APDs
  for (int ii=0;ii<nAPD;ii++){

  char name[24];
  sprintf(name,"rootfile/apd%d.root",apdID[ii]);
  TFile *f = new TFile(name,"RECREATE");

    //now open the file ".sum" for each APD, that contains the info about the number of read temperaturs, and their values
    //ifstream file1(Form("raw/%i.sum",apdID[ii]));
    ifstream file1(Form("%i.sum",apdID[ii]));	//Modified by AR 07/08/2013
    file1>>nT;
    cout<<nT<<endl;
    Tset=new double[nT];
    startT=new double[nT];
    endT=new double[nT];
    realT=new double[nT];
    

    for (int qq=0;qq<nT;qq++){
      file1>>Tset[qq]>>startT[qq]>>endT[qq];
    }
    Tmeas.clear();		
    meanTmeas.clear();
    
    Tcounter=0;
    for (Tcounter=0;Tcounter<endT[nT-1];Tcounter++){
      //cout<<Tcounter<<" "<<endT[nT-1]<<" "<<dummyS<<" "<<dummyS1<<endl;	
      file1>>dummyS>>dummyS1;
      tempTmeas=0;
      for (int qq=0;qq<NPT100;qq++){
	   file1>>singleTmeas[qq];
	   tempTmeas+=singleTmeas[qq];
      } 
      tempTmeas=tempTmeas/NPT100;
      //Tmeas.push_back(singleTmeas);
      meanTmeas.push_back(tempTmeas);

      
    }
    cout<<"End sum file for APD "<<apdID[ii]<<endl;
    file1.close();
    nData=new int[nT];
    gTemperature=new TGraph*[nT];

    for (int qq=0;qq<nT;qq++){
      gTemperature[qq]=new TGraph();
      Tcounter=0;
      tempTmeas=0;
      for (int jj=(int)startT[qq];jj<(int)endT[qq];jj++){
	gTemperature[qq]->SetPoint(Tcounter,jj,meanTmeas[jj]);
	Tcounter++;
	tempTmeas+=meanTmeas[jj];
      }
	if(Tcounter==0){
	continue;
	}
      realT[qq]=tempTmeas/Tcounter;      
      gTemperature[qq]->SetTitle(Form("T= %f",realT[qq]));      
    }
    




    TCanvas *c=new TCanvas("c","c",1000,800); //currents vs V
    TCanvas *c1=new TCanvas("c1","c1",1000,800); //correct current vs V
    TCanvas *c2=new TCanvas("c2","c2",1000,800); //G vs V
    TCanvas *c2a=new TCanvas("c2a","c2a",1000,800); //V vs G
    TCanvas *c3=new TCanvas("c3","c3",1000,800); //dark I vs G
    TCanvas *c4=new TCanvas("c4","c4",1000,800); //temperatures
    TCanvas *c5=new TCanvas("c5","c5",1000,800); //G vs T vs V
    TCanvas *c6=new TCanvas("c6","c6",1000,800); //all G vs V togheter.
    TCanvas *c7=new TCanvas("c7","c7",1000,800); //1/G dG/dV for each T
    TCanvas *c8=new TCanvas("c8","c8",1000,800); //1/G dG/dV for each T ALL TOGHETER
    TCanvas *c9=new TCanvas("c9","c9",1000,800); //which V for a fixed G? (as a function of T)
   
 
    c->Divide((int)ceil(sqrt(nT)),(int)ceil(sqrt(nT)));
    c1->Divide((int)ceil(sqrt(nT)),(int)ceil(sqrt(nT)));
    c2->Divide((int)ceil(sqrt(nT)),(int)ceil(sqrt(nT)));
    c2a->Divide((int)ceil(sqrt(nT)),(int)ceil(sqrt(nT)));
    c3->Divide((int)ceil(sqrt(nT)),(int)ceil(sqrt(nT)));
    c4->Divide((int)ceil(sqrt(nT)),(int)ceil(sqrt(nT)));
    c7->Divide((int)ceil(sqrt(nT)),(int)ceil(sqrt(nT)));

    TGraph **gG; //I vs Vr
    gG=new TGraph*[nT];

    TGraph **gG1; //Id vs Vr
    gG1=new TGraph*[nT];

    TGraphErrors **gG2; //Ir vs Vr 
    gG2=new TGraphErrors*[nT];

    TGraph **gG2a; //Ir vs Vr JUST for fit
    gG2a=new TGraph*[nT];

    TGraphErrors **gG3; //G vs Vr
    gG3=new TGraphErrors*[nT];

    TGraphErrors **gG3a; //G vs Vr for the fit, G<G0
    gG3a=new TGraphErrors*[nT];
 
    TGraph **gTemp; //Vr vs G.
    gTemp=new TGraph*[nT];    

    TGraph **gG4; //Id vs G
    gG4=new TGraph*[nT];

    TGraph **gG7; //1/G dG/dV
    gG7=new TGraph*[nT];

    TMultiGraph *gG7all=new TMultiGraph();
    
 
    TGraph **gG8;
    gG8=new TGraph*[4]; //50,100,150,200 //Andrea Delta
    TMultiGraph *gG8all=new TMultiGraph(); // ----- modified by AR 20/08/2013 ------
    for (int aa=0;aa<4;aa++) gG8[aa]=new TGraph();
    // TMultiGraph *gG8all=new TMultiGraph(); // ----- commented by AR 20/08/2013 ------
    double *slopeA=new double[4];
    
    TGraph2D *VTG=new TGraph2D();              // LT for TGraph[4]s, aa<4
    TGraph2D *GTV=new TGraph2D();
    TH2D *hGTV;
    TH2D *hVTG;
    TH1D *hProjection;

    int NVTG=0;


    TMultiGraph *gSum=new TMultiGraph("gSum","G vs V; Bias voltage (V); G");


    //for each APD, open its data file.
    cout<<"Working on APD "<<apdID[ii]<<endl;
    //data.open(Form("raw/%i.dat",apdID[ii]));
    data.open(Form("%i.dat",apdID[ii]));	// Modified by AR 07/08/2013
    if (!(data.is_open())) {
      cout<<"Error"<<endl;
      continue;
    }
    printf("We have %i Temperatures for this APD\n",nT);
    //Format of the file for each temperature is:
    //NData
    double ttV,ttVr,ttI,ttId,ttG,ttIr;
    vector<double> tV;
    vector<double> tVr; 
    vector<double> tI;
    vector<double> tId;
    vector<double> tG;
    vector<double> eG;
    vector<double> tIr;
    vector<double> eIr;
   

    for (int jj=0;jj<nT;jj++){
      data>>nData[jj];
      
      tV.clear();
      tVr.clear();
      tI.clear();
      tId.clear();
      tG.clear();
      tIr.clear();
      eIr.clear();
      eG.clear();
      for (int kk=0;kk<nData[jj];kk++){
	data>>ttV>>ttVr>>ttI>>ttId>>ttG;
	cout<<jj<<" "<<ttV<<" "<<ttVr<<" "<<ttI<<" "<<ttId<<" "<<ttG<<endl;
	if (0){//here goes the check on the current, to see if its fine. Check on BAD values;
	  continue;
	}
	if (kk==0){ //skip the first point
	  continue;
	}
	

      	ttI=ttI*1E9;
	ttId=ttId*1E9;
      	ttIr=(ttI-ttId);//currents in nA
	
	tV.push_back(ttV);
	tVr.push_back(ttVr);
		// ----- Controllo sui valori con cui riempio i vettori -----
		if(my_isinf(ttV)<2 || my_isinf(ttVr)<2){
		cout << "STOP" << endl;
		c9->WaitPrimitive();
		}
			// ----- Controllo sul vettore riempito -----
			for(int t=0;t<tVr.size();t++){
				if(my_isinf(tVr[t])<2 || my_isinf(tVr[t])<2){
				cout << tVr[t] << endl;
				}
			}	
			// ----- ------ ------ -----
	
		// ----- ------ ------ -----


	tI.push_back(ttI);
	tId.push_back(ttId);
	tIr.push_back(ttIr);
	eIr.push_back(ttIr*EI);
	//some checks here to see if currents have meaning!
      }
      V.push_back(tV);
      Vr.push_back(tVr);
      I.push_back(tI);
      Ir.push_back(tIr);
      Id.push_back(tId);
      tVr.clear(); // ----- Added by AR 23/08/2013
      


      printf("Data read: %i points \n",tV.size());
      //now we calculate the Gain for APD ii,temperature jj.
      
      int Npoints=0;
      for (int kk=0;kk<nData[jj];kk++){
	if (V[jj][kk]<V0) Npoints++;
	else break;
      }
 
      double I0,FitSlope;
    
      tVr=Vr[jj];
			// ----- Controllo sul vettore riempito -----
			for(int t=0;t<tVr.size();t++){
				if(my_isinf(tVr[t])<2)<2){
				cout << tVr[t] << endl;
				c9->WaitPrimitive();
				}
			}	
			// ----- ------ ------ -----
      tIr=Ir[jj];
      tId=Id[jj];
   
      c->cd(jj+1)->SetLogy();
      gG[jj]=new TGraph(tVr.size(),&tVr[0],&tI[0]);
      gG[jj]->SetTitle(Form("I vs V. T=%f ; V(Volt) ; I (nA)",realT[jj]));
      gG1[jj]=new TGraph(tVr.size(),&tVr[0],&tId[0]);
      gG1[jj]->SetTitle(Form("Dark Current vs V. T=%f ; V (Volt) ; Id (nA)",realT[jj]));


      gG[jj]->SetMarkerStyle(7);
      gG1[jj]->SetMarkerStyle(7);
      gG1[jj]->SetMarkerColor(2);
      gG[jj]->Draw("AP");
      gG1[jj]->Draw("PSAME");
      gG[jj]->GetYaxis()->SetRangeUser(0.1E,5E4);

      c->Modified();
      c->Update();
      

      c1->cd(jj+1)->SetLogy();
      gG2[jj]=new TGraph(tVr.size(),&tVr[0],&tIr[0]);

      gG2[jj]->SetTitle(Form("Corrected Current vs V. T = %f;V (Volt);Id(nA)",realT[jj]));
      gG2a[jj]=new TGraphErrors(Npoints,&tVr[0],&tIr[0],NULL,&eIr[0]);
      
      gG2[jj]->SetMarkerStyle(7);
      gG2[jj]->SetMarkerColor(1);
      gG2a[jj]->SetMarkerStyle(7);
      gG2a[jj]->SetMarkerColor(2);

  	
      gG2a[jj]->Fit("pol1");

      

      FitSlope=gG2a[jj]->GetFunction("pol1")->GetParameter(1);
      I0=gG2a[jj]->GetFunction("pol1")->GetParameter(0);
      
    
      
      gG2[jj]->Draw("AP");
      gG2a[jj]->Draw("PSAME");

    

      //Here start the fit for the G vs V. First find the range, G<G0     
      for (int kk=0;kk<Ir[jj].size();kk++){
	ttG=Ir[jj][kk]/I0;
	tG.push_back(ttG);
	eG.push_back(ttG*EG);
      }
      G.push_back(tG);
    
      
      gG3[jj]=new TGraphErrors(tVr.size(),&tVr[0],&tG[0],NULL,&eG[0]);
      gG3[jj]->SetTitle(Form("Gain vs V. T=%f;V (Volt);Gain",realT[jj]));
      
      
      c2->cd(jj+1)->SetLogy();
      gG3[jj]->SetMarkerStyle(7);
      gG3[jj]->Draw("AP");
     
      



      double Vend=0;
      Npoints=0;
      for (int kk=0;kk<nData[jj];kk++){
	if (G[jj][kk]<G0) {Vend=Vr[jj][kk];Npoints++;}
	else break;
      }
      gG3a[jj]=new TGraphErrors(Npoints,&tVr[0],&tG[0],NULL,&eG[0]);
      gG3a[jj]->SetMarkerColor(2);
      gG3a[jj]->SetMarkerStyle(7);
    
    

      //check: Idark vs G should be linear
      c3->cd(jj+1);
      gG4[jj]=new TGraph(tVr.size(),&tG[0],&tId[0]);
      gG4[jj]->SetMarkerStyle(7);
      gG4[jj]->GetXaxis()->SetRangeUser(10,250);
      gG4[jj]->Draw("AP");
      gG4[jj]->SetTitle(Form("Dark Current vs Gain. T=%f ;Gain; Dark Current (nA)",realT[jj]));
      gG4[jj]->Fit("pol1","R","",10,250);
      gG4[jj]->GetFunction("pol1")->SetLineWidth(1);
      gG4[jj]->GetFunction("pol1")->SetLineColor(2);
      gG4[jj]->GetFunction("pol1")->Draw("SAME");
    
      //plot the temperatures
      c4->cd(jj+1);
      gTemperature[jj]->SetMarkerStyle(20);
      gTemperature[jj]->SetMarkerColor(4);
      gTemperature[jj]->SetMarkerSize(0.5);
      gTemperature[jj]->Draw("AP");




      //Fill the 2d-graph: perform a linear interpolation at this temperature
      // - starting from GSTART
      // - moving by GDELTA
      // - considering GPOINTS
      c5->cd();
      gTemp[jj]=new TGraph(tVr.size(),&tG[0],&tVr[0]); //note the inverse order!
      double Ginter=0;
      double Vinter=0;
      for (int kk=0;kk<GPOINTS;kk++){
	Ginter=GSTART+kk*GDELTA;
	Vinter=gTemp[jj]->Eval(Ginter);
//	cout<<"Point "<<NVTG<<" : "<<jj<<" : "<<realT[jj]<<" "<<Vinter<<" "<<Ginter<<endl;
	VTG->SetPoint(NVTG,Vinter,realT[jj],Ginter);
	GTV->SetPoint(NVTG,Ginter,realT[jj],Vinter);
	NVTG++;
      }

      gSum->Add(gG3[jj],"P");
      c2a->cd(jj+1)->SetLogx();
      gTemp[jj]->SetTitle(Form("V vs Gain T=%f;Gain; V (Volt)",realT[jj]));
      gTemp[jj]->SetMarkerStyle(7);
      gTemp[jj]->Draw("AP");

     //1/G dG/dV for each temperature
     c7->cd(jj+1);
     gG7[jj]=new TGraph();
     for (int kk=0;kk<nData[jj];kk++){
	double dGG=gG3[jj]->Eval(tVr[kk],0,"S");
	double dGG1=gG3[jj]->Eval(tVr[kk]+EPS,0,"S");
	dGG1=dGG1-dGG; //difference
	dGG1=dGG1/EPS; //derivative
	dGG1=dGG1/dGG; //relative gain difference
	gG7[jj]->SetPoint(kk,dGG,dGG1);	
      }
    gG7[jj]->SetMarkerStyle(20);
    gG7[jj]->Draw("AP");
    gG7[jj]->SetMarkerColor(jj+1);	
    gG7all->Add(gG7[jj],"P");	


    }//end cicle temperature jj for APD ii
  
    c8->cd();
    gG7all->Draw("A");


    gStyle->SetPalette(1);
    gStyle->SetNumberContours(25);

    
    c9->cd();
    for (int jj=0;jj<nT;jj++){

// ----- Added by AR 20/08/2013 -----
    int controllo =1;
	gTemp[jj]->Sort();
		// ----- Funzione di controllo per gli infiniti e i NaN -----
		// ----- ----- ----- ----- ----- ----
	/*Andrea delta. Comment from here
	if((my_isinf(gTemp[jj]->Eval(50,0,""))<2)||(my_isinf(realT[jj])<2)){
		if((my_isinf(realT[jj])<2)){
		gG8[0]->SetPoint(jj,gTemp[jj]->Eval(50,0,""),1);
		}
		else if(my_isinf(gTemp[jj]->Eval(50,0,""))<2){
		gG8[0]->SetPoint(jj,(gTemp[jj-1]->Eval(50,0,"")+gTemp[jj+1]->Eval(50,0,""))/2,realT[jj]);
		}
	}
	else{
	gG8[0]->SetPoint(jj,gTemp[jj]->Eval(50,0,""),realT[jj]);
	}
	* Andrea delta comment to here*/
	if((my_isinf(gTemp[jj]->Eval(100,0,""))<2)||(my_isinf(realT[jj])<2)){
		if((my_isinf(realT[jj])<2)){
		  gG8[0]->SetPoint(jj,gTemp[jj]->Eval(100,0,""),1); /*Andrea delta gG8[1] -> gG8[0]*/
		}
		else if(my_isinf(gTemp[jj]->Eval(100,0,""))<2){
		gG8[0]->SetPoint(jj,(gTemp[jj-1]->Eval(100,0,"S")+gTemp[jj+1]->Eval(100,0,""))/2,realT[jj]); /*Andrea delta gG8[1] -> gG8[0]*/
		}
	}
	else{
	gG8[0]->SetPoint(jj,gTemp[jj]->Eval(100,0,""),realT[jj]);/*Andrea delta gG8[1] -> gG8[0]*/
	}
		
	if((my_isinf(gTemp[jj]->Eval(150,0,""))<2)||(my_isinf(realT[jj])<2)){
		if((my_isinf(realT[jj])<2)){
		gG8[1]->SetPoint(jj,gTemp[jj]->Eval(150,0,""),1);/*Andrea delta gG8[2] -> gG8[1]*/
		}
		else if(my_isinf(gTemp[jj]->Eval(150,0,""))<2){
		gG8[1]->SetPoint(jj,(gTemp[jj-1]->Eval(150,0,"")+gTemp[jj+1]->Eval(150,0,""))/2,realT[jj]);/*Andrea delta gG8[2] -> gG8[1]*/
		}
	}
	else{
	gG8[1]->SetPoint(jj,gTemp[jj]->Eval(150,0,""),realT[jj]);/*Andrea delta gG8[2] -> gG8[1]*/
	}

	if((my_isinf(gTemp[jj]->Eval(200,0,""))<2)||(my_isinf(realT[jj])<2)){
		if((my_isinf(realT[jj])<2)){
		gG8[2]->SetPoint(jj,gTemp[jj]->Eval(200,0,""),1);/*Andrea delta gG8[3] -> gG8[2]*/
		}
		else if(my_isinf(gTemp[jj]->Eval(200,0,""))<2){
		gG8[2]->SetPoint(jj,(gTemp[jj-1]->Eval(200,0,"")+gTemp[jj+1]->Eval(200,0,""))/2,realT[jj]);/*Andrea delta gG8[3] -> gG8[2]*/
		}
	}
	else{
	gG8[2]->SetPoint(jj,gTemp[jj]->Eval(200,0,""),realT[jj]);/*Andrea delta gG8[3] -> gG8[2]*/
	}

	// ----- ----- ----- ----- ----- ----
	

    }
    

    for (int aa=0;aa<4;aa++){ /*Andrea delta: aa<4 -> aa<3*/
      gG8[aa]->SetMarkerStyle(20);                                               // LT aa<4
	gG8[aa]->SetMarkerColor(aa+1);
	
	// ----- Modified by AR 20/08/2013 -----
	//gG8[aa]->Fit("pol1");
	//slopeA[aa]=gG8[aa]->GetFunction("pol1")->GetParameter(1);
	//slopeA[aa]=0;
	if(controllo==1){
		// ----- Inizializzazione corretta del fit lineare ------
		double x1[4],y1[4],x2[4],y2[4];
		int base=0;
			// ----- Richiedo che i due punti da utilizzare per inizializzare il fit lineare non presentino valori strani -----
enter:				
			for(int ia=base;ia<(nT-1);ia++){
			gG8[aa]->GetPoint(ia,x1[aa],y1[aa]);
				if((((my_isinf(x1[aa]))>1)&&((my_isinf(y1[aa]))>1))&&((x1[aa]!=0)&&(y1[aa]!=0))){
					for(int ja=ia+1;ja<nT;ja++){
					gG8[aa]->GetPoint(ja,x2[aa],y2[aa]);
						if((((my_isinf(x2[aa]))>1)&&((my_isinf(y2[aa]))>1))&&((x2[aa]!=0)&&(y2[aa]!=0))){
						//cout << "*********************************************************" << endl;
						//cout << x1[aa] << " " << y1[aa] << " " << x2[aa] << " " << y2[aa] << " i punti sono " << ia << " " << ja << " " << aa << endl;
						//cout << "*********************************************************" << endl;
						goto exit;
						}
					}
				}
			}
			// ----- ----- ----- ----- ----- ----
exit: 
		// ----- Calcolo dei parametri di inizializzazione del fit lineare -----
		c9->cd(1);
		//gG8[aa]->Draw();
		c9->Update();
		cout << controllo << "******* ***** ******* ******* ****** ******* ****** ******* " << endl;


		double slope[4];
		double cnst[4];
		
		slope[aa]=(y2[aa]-y1[aa])/(x2[aa]-x1[aa]);
		cnst[aa]=0.5*(y1[aa]+y2[aa]-slope[aa]*(x1[aa]+x2[aa]));
		//cout << "*********************************************************" << endl;
		//cout << slope[aa] << " " << cnst[aa] << "per il grafico " << aa << " " << ia << " " << ja << endl; 
		//cout << "*********************************************************" << endl;
		if((my_isinf(slope[aa]))<2||(my_isinf(cnst[aa]))<2){
		base = ia+1;
		goto enter;
		}

	
		// ----- ----- ----- ----- ----- ----
		// ----- Definizione della funzione lineare per il fit -----
	 	TF1 *myline = new TF1("mylyne","[0]*x + [1]");
		myline->SetParameter(0,slope[aa]);	
		myline->SetParameter(1,cnst[aa]);
		cout << "*********************************************************" << endl;
		cout << myline->GetParameter(0) << " " << slope[aa ] << " " << myline->GetParameter(1) << cnst[aa] << "per il grafico " << aa << " " << ia << " " << ja << endl; 
		cout << "*********************************************************" << endl;
			

		// ----- ----- ----- ----- ----- ----
		gG8[aa]->Fit(myline);
			
		if(((my_isinf(myline->GetParameter(0))<2)||(my_isinf(myline->GetParameter(1))<2))||((abs(myline->GetParameter(0))>100000)||(abs(myline->GetParameter(1))>100000))){
			if(ia+1<nT-1){
			base = ia+1;
			goto enter;
			}
			else{
			base=0;
			goto exit;
			}
			base=0;
		}


		c9->Update();



		// ----- ----- ----- ----- ----- ----
	// ----- ----- ----- ----- ----- ----

	


	gG8all->Add(gG8[aa],"P");
	}
	slopeA[aa]=myline->GetParameter(0);
   }
	
   c9->cd();

   gG8all->SetTitle("Voltage corresponding to fixed gain, as a function of temperature; V (Volt) ; T(deg)");
   // gG8[0]->GetXaxis()->SetRangeUser(370,400);
   // gG8[0]->GetYaxis()->SetRangeUser(15,30);
   gG8all->Draw("A");

    c5->Divide(1,2);
    c5->cd(2);
    c5->SetGridx();
    c5->SetGridy();
 
    GTV->Draw("colz");
    // VTG->Draw("colz");

   
    hGTV=GTV->GetHistogram();
    hGTV=GTV->Draw("colz");
    hGTV->SetTitle("Temp vs Gain;Gain;T(deg C)");
    c5->cd(1);
    VTG->SetNpx(150);     // 7/22/14 Change 150 to 500 to increase coverage
    VTG->SetNpy(150);     // 7/22/14 Change 150 to 500 to increase coverage
    VTG->Draw("colz");  
    hVTG=VTG->GetHistogram();
    hVTG->SetTitle("Temp vs Voltage;Voltage(V);T(deg C)");
    hVTG->Draw("colzCONT2");
    c5->Update(); 

    //    fun->Draw("SAME");

    c6->cd();
    gSum->Draw("A");
    gSum->GetXaxis()->SetRangeUser(gTemp[0]->Eval(40),gTemp[0]->Eval(180));


    	//now find V for G=150 @ +18
    	//we save ALL the results in file, in folder "Results"
    	//we use interpolation!
    	// ----- Variabili aggiunte per la tree -----
    		// ----- Added by AR 19/09/2013 -----
//		cout << V1 << " V  " << T3 << " T"<<endl;  
//		cout << (hVTG->GetXaxis())->GetXmax() << " massimo X  " << (hVTG->GetXaxis())->GetXmin() << " minimo X"<<endl;  
//		cout << (hVTG->GetYaxis())->GetXmax() << " massimo Y  " << (hVTG->GetYaxis())->GetXmin() << " minimo Y"<<endl;  

//Changed by HS on 15May2014//
                double V1_25=hVTG->Interpolate(hGTV->Interpolate(50,T4),T4);
                double V2_25=hVTG->Interpolate(hGTV->Interpolate(100,T4),T4);
                double V3_25=hVTG->Interpolate(hGTV->Interpolate(150,T4),T4);       // LT
                double V1_20=hVTG->Interpolate(hGTV->Interpolate(50,T3),T3);
                double V2_20=hVTG->Interpolate(hGTV->Interpolate(100,T3),T3);
                double V3_20=hVTG->Interpolate(hGTV->Interpolate(150,T3),T3);  
    		double V1_18=hVTG->Interpolate(hGTV->Interpolate(50,T2),T2);
    		double V2_18=hVTG->Interpolate(hGTV->Interpolate(100,T2),T2);
    		double V3_18=hVTG->Interpolate(hGTV->Interpolate(150,T2),T2);  //Interpolate the gain at Vmeasured and 18C
    		double V1_16=hVTG->Interpolate(hGTV->Interpolate(50,T1),T1);
    		double V2_16=hVTG->Interpolate(hGTV->Interpolate(100,T1),T1);
    		double V3_16=hVTG->Interpolate(hGTV->Interpolate(150,T1),T1); 
		double grpGN=hVTG->Interpolate(405.4,T2);//new line to change


	
		// ----- ------ -----

        	double G1_25=hGTV->Interpolate(G1,T4);
    		double G2_25=hGTV->Interpolate(G2,T4);                  // LT
    		double G3_25=hGTV->Interpolate(G3,T4);  
		double G1_20=hGTV->Interpolate(G1,T3);
    		double G2_20=hGTV->Interpolate(G2,T3);
    		double G3_20=hGTV->Interpolate(G3,T3);  
    		double G1_18=hGTV->Interpolate(G1,T2);
    		double G2_18=hGTV->Interpolate(G2,T2);
    		double G3_18=hGTV->Interpolate(G3,T2);  
    		double G1_16=hGTV->Interpolate(G1,T1);
    		double G2_16=hGTV->Interpolate(G2,T1);
    		double G3_16=hGTV->Interpolate(G3,T1); 

    		//now find V for G=150 @ +18
    		//we use interpolation!
   		// ----- -----


	// ----- Modified by AR 19/09/2013 -----
    ofstream ofile;
    ofile.open(Form("Results/%i.txt",apdID[ii]));
    ofile<<"RESULTS FOR APD "<<apdID[ii]<<endl;
    ofile<<"********************************"<<endl<<endl;
    ofile<< "Gains= " << G1 << " " << G2 << " " << G3 << endl;
    ofile<< "Temperatures= " << T1 << " " << T2 << " " << T3 << T4 <<  endl;              // LT
    ofile<< "Vref= " << V1 << " " << V2 << " " << V3 << endl;
    ofile<<"********************************"<<endl<<endl;
    ofile<<" Vref @ fixed Gain and Temperature "<<endl<<endl;
    ofile<<"********************************"<<endl<<endl;
    ofile<<"G=" << G1 << " @ "<< T4 << " C for V= "<<G1_25 << " V"<<endl; 
    ofile<<"G=" << G2 << " @ "<< T4 << " C for V= "<<G2_25<< " V"<<endl;                     // LT
    ofile<<"G=" << G3 << " @ "<< T4 << " C for V= "<<G3_25<< " V"<<endl; 
    ofile<<"G=" << G1 << " @ "<< T3 << " C for V= "<<G1_20 << " V"<<endl; 
    ofile<<"G=" << G2 << " @ "<< T3 << " C for V= "<<G2_20<< " V"<<endl; 
    ofile<<"G=" << G3 << " @ "<< T3 << " C for V= "<<G3_20<< " V"<<endl; 
    ofile<<"G=" << G1 << " @ "<< T2 << " C for V= "<<G1_18<< " V"<<endl; 
    ofile<<"G=" << G2 << " @ "<< T2 << " C for V= "<<G2_18<< " V"<<endl; 
    ofile<<"G=" << G3 << " @ "<< T2 << " C for V= "<<G3_18<< " V"<<endl; 
    ofile<<"G=" << G1 << " @ "<< T1 << " C for V= "<<G1_16<< " V"<<endl; 
    ofile<<"G=" << G2 << " @ "<< T1 << " C for V= "<<G2_16<< " V"<<endl;               // T3s changed to T1s LT
    ofile<<"G=" << G3 << " @ "<< T1 << " C for V= "<<G3_16<< " V"<<endl; 
    ofile<<"********************************"<<endl<<endl;
    ofile<<" G @ fixed Temperature and Vref "<<endl<<endl;
    ofile<<"********************************"<<endl<<endl;
    ofile<<"V=" << V1 << " V @ "<< T4 << " C for G= "<<V1_25<<endl; 
    ofile<<"V=" << V2 << " V @ "<< T4 << " C for G= "<<V2_25<<endl;                      // LT
    ofile<<"V=" << V3 << " V @ "<< T4 << " C for G= "<<V3_25<<endl; 
    ofile<<"V=" << V1 << " V @ "<< T3 << " C for G= "<<V1_20<<endl; 
    ofile<<"V=" << V2 << " V @ "<< T3 << " C for G= "<<V2_20<<endl; 
    ofile<<"V=" << V3 << " V @ "<< T3 << " C for G= "<<V3_20<<endl; 
    ofile<<"V=" << V1 << " V @ "<< T2 << " C for G= "<<V1_18<<endl; 
    ofile<<"V=" << V2 << " V @ "<< T2 << " C for G= "<<V2_18<<endl; 
    ofile<<"V=" << V3 << " V @ "<< T2 << " C for G= "<<V3_18<<endl; 
    ofile<<"V=" << V1 << " V @ "<< T1 << " C for G= "<<V1_16<<endl; 
    ofile<<"V=" << V2 << " V @ "<< T1 << " C for G= "<<V2_16<<endl; 
    ofile<<"V=" << V3 << " V @ "<< T1 << " C for G= "<<V3_16<<endl; 
    ofile<<"********************************"<<endl<<endl;
	// ------ ----- ------ ------    	

    ofile<<"Gain G(alpha * V - beta * T). The ration alpha / beta : "<<endl;
    ofile<<TMath::Mean(4,slopeA)<<" +- "<<TMath::RMS(4,slopeA)<<endl;
    ofile.close();
	// ----- Create the tree -----
	TTree *tree = new TTree("T","Staff");
	// ----- -----
	// ----- Definizione del branch della tree -----
	apd_t apd;
	tree->Branch("apdb",&apd.id,"id/d:   G1_25:G2_25:G3_25:G1_20:G2_20:G3_20:G1_18:G2_18:G3_18:G1_16:G2_16:G3_16:V1_25:V2_25:V3_25:V1_20:V2_20:V3_20:V1_18:V2_18:V3_18:V1_16:V2_16:V3_16:ratio:delta_ratio:Vbreak:VHam:grpGN:ok_flag/I");  // LT
	// ----- -----
	// ----- Giusta corrispondenza variabili reali e quelle della struttura -----
	
//	cout << "please insert the Vb value for the APD "<< apdID[ii] << endl;
//	cin >> Vbreak;


	apd.id=apdID[ii];
	apd.G1_25=G1_25;	
	apd.G2_25=G2_25;	
	apd.G3_25=G3_25;
	apd.G1_20=G1_20;	// LT
	apd.G2_20=G2_20;	
	apd.G3_20=G3_20;	
	apd.G1_18=G1_18;	
	apd.G2_18=G2_18;	
	apd.G3_18=G3_18;	
	apd.G1_16=G1_16;	
	apd.G2_16=G2_16;	
	apd.G3_16=G3_16;
	apd.V1_25=V1_25;	
	apd.V2_25=V2_25;	// LT
	apd.V3_25=V3_25;
	apd.V1_20=V1_20;	
	apd.V2_20=V2_20;	
	apd.V3_20=V3_20;	
	apd.V1_18=V1_18;	
	apd.V2_18=V2_18;	
	apd.V3_18=V3_18;	
	apd.V1_16=V1_16;	
	apd.V2_16=V2_16;	
	apd.V3_16=V3_16;	
	ratio=TMath::Mean(4,slopeA);
	apd.ratio=ratio;
	delta_ratio=TMath::RMS(4,slopeA);
	apd.delta_ratio=delta_ratio;
	apd.Vbreak=Vbreak[ii];	
	apd.VHam=VHam[ii];
	apd.grpGN=grpGN;
	apd.ok_flag=ok_flag[ii];
	tree->Fill();
	f->Write();
	f->Close();
	// ----- -----

    c->Print(Form("PDF/%i.pdf(",apdID[ii]));
    c1->Print(Form("PDF/%i.pdf",apdID[ii]));
    c2->Print(Form("PDF/%i.pdf",apdID[ii]));
    c3->Print(Form("PDF/%i.pdf",apdID[ii]));
    c4->Print(Form("PDF/%i.pdf",apdID[ii]));
    c5->Print(Form("PDF/%i.pdf",apdID[ii]));
    c7->Print(Form("PDF/%i.pdf",apdID[ii]));
    c8->Print(Form("PDF/%i.pdf",apdID[ii]));
    c9->Print(Form("PDF/%i.pdf",apdID[ii]));
    c6->Print(Form("PDF/%i.pdf)",apdID[ii]));


    c->Print(Form("C/%i.C",apdID[ii]*100+1));
    c1->Print(Form("C/%i.C",apdID[ii]*100+2));
    c2->Print(Form("C/%i.C",apdID[ii]*100+3));
    c3->Print(Form("C/%i.C",apdID[ii]*100+4));
    c4->Print(Form("C/%i.C",apdID[ii]*100+5));
    c5->Print(Form("C/%i.C",apdID[ii]*100+6));
    c7->Print(Form("C/%i.C",apdID[ii]*100+7));
    c8->Print(Form("C/%i.C",apdID[ii]*100+8));
    c9->Print(Form("C/%i.C",apdID[ii]*100+9));
    c6->Print(Form("C/%i.C",apdID[ii]*100+10));

    I.clear();
    Ir.clear();
    Id.clear();
    V.clear();
    Vr.clear();
    G.clear();

    data.close();
  }//end for APD 


}



        	int my_isinf(double x)
        	{
        	volatile double temp = x;
        		if ((temp == x)&&((temp-x)!=0) ){
        		return 0;
        		}
			if(temp!=temp){
			return 1;
			}
			else {
			return 2;
			}
        	}
